Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents txtDepth As System.Windows.Forms.TextBox
    Friend WithEvents btnGo As System.Windows.Forms.Button
    Friend WithEvents chkRefresh As System.Windows.Forms.CheckBox
    Friend WithEvents picCanvas As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label
        Me.txtDepth = New System.Windows.Forms.TextBox
        Me.btnGo = New System.Windows.Forms.Button
        Me.chkRefresh = New System.Windows.Forms.CheckBox
        Me.picCanvas = New System.Windows.Forms.PictureBox
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.AutoSize = True
        Me.Label1.Location = New System.Drawing.Point(8, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(34, 16)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Depth"
        '
        'txtDepth
        '
        Me.txtDepth.Location = New System.Drawing.Point(48, 8)
        Me.txtDepth.Name = "txtDepth"
        Me.txtDepth.Size = New System.Drawing.Size(32, 20)
        Me.txtDepth.TabIndex = 1
        Me.txtDepth.Text = "4"
        '
        'btnGo
        '
        Me.btnGo.Location = New System.Drawing.Point(24, 40)
        Me.btnGo.Name = "btnGo"
        Me.btnGo.Size = New System.Drawing.Size(40, 24)
        Me.btnGo.TabIndex = 2
        Me.btnGo.Text = "Go"
        '
        'chkRefresh
        '
        Me.chkRefresh.Location = New System.Drawing.Point(16, 72)
        Me.chkRefresh.Name = "chkRefresh"
        Me.chkRefresh.Size = New System.Drawing.Size(64, 16)
        Me.chkRefresh.TabIndex = 3
        Me.chkRefresh.Text = "Refresh"
        '
        'picCanvas
        '
        Me.picCanvas.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.picCanvas.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.picCanvas.Location = New System.Drawing.Point(88, 0)
        Me.picCanvas.Name = "picCanvas"
        Me.picCanvas.Size = New System.Drawing.Size(272, 272)
        Me.picCanvas.TabIndex = 4
        Me.picCanvas.TabStop = False
        '
        'Form1
        '
        Me.AcceptButton = Me.btnGo
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(360, 273)
        Me.Controls.Add(Me.picCanvas)
        Me.Controls.Add(Me.chkRefresh)
        Me.Controls.Add(Me.btnGo)
        Me.Controls.Add(Me.txtDepth)
        Me.Controls.Add(Me.Label1)
        Me.Name = "Form1"
        Me.Text = "Hilbert"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private m_Refresh As Boolean
    Private m_X As Integer
    Private m_Y As Integer
    Private m_Bm As Bitmap

    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        m_Bm = New Bitmap(picCanvas.ClientSize.Width, picCanvas.ClientSize.Height)
        Dim gr As Graphics = Graphics.FromImage(m_Bm)
        picCanvas.Image = m_Bm
        Dim depth As Integer = Integer.Parse(txtDepth.Text)
        If depth > 8 Then
            If MessageBox.Show("A large depth may take a long time to draw. Do you want to continue?", _
                "Continue?", MessageBoxButtons.YesNo, _
                MessageBoxIcon.Question) = DialogResult.No _
            Then
                Exit Sub
            End If
        End If

        gr.Clear(picCanvas.BackColor)
        picCanvas.Image = m_Bm
        Me.Cursor = Cursors.WaitCursor
        Application.DoEvents()

        ' See if we should refresh as we draw.
        m_Refresh = chkRefresh.Checked

        ' Get the parameters.
        Dim total_length As Double
        Dim start_x As Double
        Dim start_y As Double
        Dim start_length As Double

        ' See how big we can make the curve.
        If picCanvas.ClientSize.Height < picCanvas.ClientSize.Width Then
            total_length = 0.9 * picCanvas.ClientSize.Height
        Else
            total_length = 0.9 * picCanvas.ClientSize.Width
        End If

        start_x = (picCanvas.ClientSize.Width - total_length) / 2
        start_y = (picCanvas.ClientSize.Height - total_length) / 2

        ' Compute the side length for this level.
        start_length = total_length / (2 ^ depth - 1)

        ' Draw the curve.
        m_X = CInt(start_x)
        m_Y = CInt(start_y)
        Hilbert(gr, depth, start_length, 0)

        ' Display the result.
        picCanvas.Image = m_Bm
        gr.Dispose()
        Me.Cursor = Cursors.Default
    End Sub

    ' Draw a Hilbert curve.
    Private Sub Hilbert(ByVal gr As Graphics, ByVal depth As Integer, ByVal dx As Double, ByVal dy As Double)
        If depth > 1 Then Hilbert(gr, depth - 1, dy, dx)
        DrawRelative(gr, dx, dy)
        If depth > 1 Then Hilbert(gr, depth - 1, dx, dy)
        DrawRelative(gr, dy, dx)
        If depth > 1 Then Hilbert(gr, depth - 1, dx, dy)
        DrawRelative(gr, -dx, -dy)
        If depth > 1 Then Hilbert(gr, depth - 1, -dy, -dx)

        If m_Refresh Then picCanvas.Refresh()
    End Sub

    ' Draw the line (m_X, m_Y)-(m_X + dx, m_Y + dy) and
    ' update m_X = m_X + dx, m_Y = m_Y + dy.
    Private Sub DrawRelative(ByVal gr As Graphics, ByVal dx As Double, ByVal dy As Double)
        gr.DrawLine(Pens.Black, m_X, m_Y, CInt(m_X + dx), CInt(m_Y + dy))
        m_X = CInt(m_X + dx)
        m_Y = CInt(m_Y + dy)
    End Sub
End Class
